package qos

import "fmt"

type IOTag string

const (
	IOTagClient     IOTag = "client"
	IOTagInternal   IOTag = "internal"
	IOTagBackground IOTag = "background"
	IOTagWritecache IOTag = "writecache"
	IOTagPolicer    IOTag = "policer"
	IOTagCritical   IOTag = "critical"

	ioTagUnknown IOTag = ""
)

func FromRawString(s string) (IOTag, error) {
	switch s {
	case string(IOTagCritical):
		return IOTagCritical, nil
	case string(IOTagClient):
		return IOTagClient, nil
	case string(IOTagInternal):
		return IOTagInternal, nil
	case string(IOTagBackground):
		return IOTagBackground, nil
	case string(IOTagWritecache):
		return IOTagWritecache, nil
	case string(IOTagPolicer):
		return IOTagPolicer, nil
	default:
		return ioTagUnknown, fmt.Errorf("unknown tag %s", s)
	}
}

func (t IOTag) String() string {
	return string(t)
}
